ScatterGL (Angular)

이 샘플은 고성능 WebGL 렌더링을 사용하여, 대량의 데이터가 있는 산포도(Scatter Chart)를 보여줍니다.

이 데모는 Angular를 기반으로합니다.

import 'bootstrap.css'; import '@grapecity/wijmo.styles/wijmo.css'; import './styles.css'; // import '@angular/compiler'; import { Component, enableProdMode, NgModule, Inject } from '@angular/core'; import { FormsModule } from '@angular/forms'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { BrowserModule } from '@angular/platform-browser'; import { WjInputModule } from '@grapecity/wijmo.angular2.input'; import { WjChartModule } from '@grapecity/wijmo.angular2.chart'; import { WjChartInteractionModule } from '@grapecity/wijmo.angular2.chart.interaction'; import { isIE } from '@grapecity/wijmo'; import * as wjChart from '@grapecity/wijmo.chart'; import { DataService } from './app.data'; import { WebGLRenderEngine } from '@grapecity/wijmo.chart.webgl'; // // @Component({ selector: 'app-component', templateUrl: 'src/app.component.html' }) export class AppComponent { private _numberOfPoints: number = isIE() ? 10000 : 100000; private _numberOfSeries: number = 1; private _seriesSymbol: string = 'Dot'; symbolSize: number = 3; useWebGL: boolean = true; data: any[] = []; notIE: boolean = !isIE(); // private _chart: wjChart.FlexChart; private _webglEng = new WebGLRenderEngine(); private _svgEng = new wjChart.SvgRenderEngine(); // constructor(@Inject(DataService) private dataService: DataService) {} // get numberOfPoints(): number { return this._numberOfPoints; } set numberOfPoints(value: number) { this._numberOfPoints = value; this.updateData(); } // get numberOfSeries(): number { return this._numberOfSeries; } set numberOfSeries(value: number) { this._numberOfSeries = value; this.updateData(); } // get seriesSymbol(): string { return this._seriesSymbol; } set seriesSymbol(value: string) { this._seriesSymbol = value; } // get renderEngine(): wjChart.IRenderEngine { return this.useWebGL ? this._webglEng : this._svgEng; } // chartInitialized(chart: wjChart.FlexChart) { this._chart = chart; this.updateData(); } // updateData() { if (this._chart) { const data = []; const nser = this.numberOfSeries; const npts = this.numberOfPoints; for (let i = 0; i < nser; i++) { data.push(this.dataService.getData(Math.random() - 0.5, Math.random() - 0.5, npts / nser, 0.5 * (1 - i / nser))); } this.data = data; } } } // @NgModule({ imports: [BrowserModule, FormsModule, WjInputModule, WjChartModule, WjChartInteractionModule], declarations: [AppComponent], bootstrap: [AppComponent], providers: [DataService], }) export class AppModule { } // enableProdMode(); // Bootstrap application with hash style navigation and global services. platformBrowserDynamic().bootstrapModule(AppModule);
<!DOCTYPE html> <html lang="en"> <head> <meta charset="utf-8"> <meta http-equiv="X-UA-Compatible" content="IE=edge"> <title>WebGL</title> <meta name="viewport" content="width=device-width, initial-scale=1.0"> <!-- Polyfills --> <script src="node_modules/core-js/client/shim.min.js"></script> <script src="node_modules/zone.js/fesm2015/zone.min.js"></script> <!-- SystemJS --> <script src="node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> // workaround to load 'rxjs/operators' from the rxjs bundle System.import('rxjs').then(function (m) { System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators)); System.import('./src/app.component'); }); </script> </head> <body> <app-component></app-component> </body> </html>
<div class='container-fluid'> <div class="row"> <div class="col-sm-12"> <wj-menu header="NumPoints" [(value)]="numberOfPoints"> <wj-menu-item [value]="1000">1K</wj-menu-item> <wj-menu-item [value]="10000">10K</wj-menu-item> <wj-menu-item [value]="100000">100K</wj-menu-item> <wj-menu-item *ngIf="notIE" [value]="200000">200K</wj-menu-item> <wj-menu-item *ngIf="notIE" [value]="500000">500K</wj-menu-item> </wj-menu> <wj-menu header="NumSeries" [(value)]="numberOfSeries"> <wj-menu-item [value]="1">1</wj-menu-item> <wj-menu-item [value]="2">2</wj-menu-item> <wj-menu-item [value]="4">4</wj-menu-item> <wj-menu-item [value]="8">8</wj-menu-item> </wj-menu> <wj-menu header="Symbol" [(value)]="seriesSymbol"> <wj-menu-item [value]="'Dot'">Dot</wj-menu-item> <wj-menu-item [value]="'Box'">Box</wj-menu-item> </wj-menu> <wj-menu header="Size" [(value)]="symbolSize"> <wj-menu-item [value]="3">3</wj-menu-item> <wj-menu-item [value]="5">5</wj-menu-item> <wj-menu-item [value]="10">10</wj-menu-item> <wj-menu-item [value]="20">20</wj-menu-item> <wj-menu-item [value]="50">50</wj-menu-item> </wj-menu> <label> Use WebGL <input id="webgl" type="checkbox" [(ngModel)]="useWebGL" /> </label> </div> </div> <div class="row"> <div class="col-sm-12"> <wj-flex-chart #chart [renderEngine]="renderEngine" chartType="Scatter" bindingX="x" binding="y" [symbolSize]="symbolSize" (initialized)="chartInitialized(chart)" > <wj-flex-chart-axis wjProperty="axisX" [min]="-2" [max]="2"></wj-flex-chart-axis> <wj-flex-chart-axis wjProperty="axisY" [min]="-2" [max]="2" [axisLine]="true" [majorGrid]="false"></wj-flex-chart-axis> <wj-flex-chart-gestures #gestures interactiveAxes="XY" mouseAction="Zoom" [scaleY]="1" [posY]="0.5" [scaleX]="1" [posX]="0.5"></wj-flex-chart-gestures> <wj-flex-chart-series *ngFor="let series of data; let i = index" [itemsSource]="series" [name]="'ser ' + (i + 1)" [symbolStyle] = "{strokeWidth: 0}" [symbolMarker]="seriesSymbol"></wj-flex-chart-series> </wj-flex-chart> </div> </div> <div class="row"> <div class="col-sm-12"> <button id="btnNew" (click)="updateData()">Refresh Data</button> <button id="btnReset" (click)="gestures.reset()">Reset Zoom</button> </div> </div> </div>
import { Injectable } from '@angular/core'; // @Injectable() export class DataService { getData(cx: number, cy: number, n: number, maxr: number) { let data = new Array(n); let r0 = 0.1 + maxr; for (let i = 0; i < data.length; i++) { let a = 2 * Math.PI * Math.random(); let r = r0 * Math.sqrt(-2 * Math.log(Math.random())); data[i] = { x: cx + r * Math.cos(a), y: cy + r * Math.sin(a) }; } return data; } }
.wj-flexchart { width: 600px; height: 500px; margin: 0; }
(function (global) { SystemJS.config({ transpiler: './plugin-typescript.js', typescriptOptions: { "target": "ES2022", "module": "system", "emitDecoratorMetadata": true, "experimentalDecorators": true, }, baseURL: 'node_modules/', meta: { 'typescript': { "exports": "ts" }, '*.css': { loader: 'systemjs-plugin-css' } }, paths: { // paths serve as alias 'npm:': '' }, packageConfigPaths: [ '/node_modules/*/package.json', "/node_modules/@angular/*/package.json", "/node_modules/@grapecity/*/package.json" ], map: { 'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js', 'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js', "rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js", 'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js', '@grapecity/wijmo': 'npm:@grapecity/wijmo/index.js', '@grapecity/wijmo.input': 'npm:@grapecity/wijmo.input/index.js', '@grapecity/wijmo.styles': 'npm:@grapecity/wijmo.styles', '@grapecity/wijmo.cultures': 'npm:@grapecity/wijmo.cultures', '@grapecity/wijmo.chart': 'npm:@grapecity/wijmo.chart/index.js', '@grapecity/wijmo.chart.analytics': 'npm:@grapecity/wijmo.chart.analytics/index.js', '@grapecity/wijmo.chart.animation': 'npm:@grapecity/wijmo.chart.animation/index.js', '@grapecity/wijmo.chart.annotation': 'npm:@grapecity/wijmo.chart.annotation/index.js', '@grapecity/wijmo.chart.finance': 'npm:@grapecity/wijmo.chart.finance/index.js', '@grapecity/wijmo.chart.finance.analytics': 'npm:@grapecity/wijmo.chart.finance.analytics/index.js', '@grapecity/wijmo.chart.hierarchical': 'npm:@grapecity/wijmo.chart.hierarchical/index.js', '@grapecity/wijmo.chart.interaction': 'npm:@grapecity/wijmo.chart.interaction/index.js', '@grapecity/wijmo.chart.radar': 'npm:@grapecity/wijmo.chart.radar/index.js', '@grapecity/wijmo.chart.render': 'npm:@grapecity/wijmo.chart.render/index.js', '@grapecity/wijmo.chart.webgl': 'npm:@grapecity/wijmo.chart.webgl/index.js', '@grapecity/wijmo.chart.map': 'npm:@grapecity/wijmo.chart.map/index.js', '@grapecity/wijmo.gauge': 'npm:@grapecity/wijmo.gauge/index.js', '@grapecity/wijmo.grid': 'npm:@grapecity/wijmo.grid/index.js', '@grapecity/wijmo.grid.detail': 'npm:@grapecity/wijmo.grid.detail/index.js', '@grapecity/wijmo.grid.filter': 'npm:@grapecity/wijmo.grid.filter/index.js', '@grapecity/wijmo.grid.search': 'npm:@grapecity/wijmo.grid.search/index.js', '@grapecity/wijmo.grid.grouppanel': 'npm:@grapecity/wijmo.grid.grouppanel/index.js', '@grapecity/wijmo.grid.multirow': 'npm:@grapecity/wijmo.grid.multirow/index.js', '@grapecity/wijmo.grid.transposed': 'npm:@grapecity/wijmo.grid.transposed/index.js', '@grapecity/wijmo.grid.transposedmultirow': 'npm:@grapecity/wijmo.grid.transposedmultirow/index.js', '@grapecity/wijmo.grid.pdf': 'npm:@grapecity/wijmo.grid.pdf/index.js', '@grapecity/wijmo.grid.sheet': 'npm:@grapecity/wijmo.grid.sheet/index.js', '@grapecity/wijmo.grid.xlsx': 'npm:@grapecity/wijmo.grid.xlsx/index.js', '@grapecity/wijmo.grid.selector': 'npm:@grapecity/wijmo.grid.selector/index.js', '@grapecity/wijmo.grid.cellmaker': 'npm:@grapecity/wijmo.grid.cellmaker/index.js', '@grapecity/wijmo.nav': 'npm:@grapecity/wijmo.nav/index.js', '@grapecity/wijmo.odata': 'npm:@grapecity/wijmo.odata/index.js', '@grapecity/wijmo.olap': 'npm:@grapecity/wijmo.olap/index.js', '@grapecity/wijmo.rest': 'npm:@grapecity/wijmo.rest/index.js', '@grapecity/wijmo.pdf': 'npm:@grapecity/wijmo.pdf/index.js', '@grapecity/wijmo.pdf.security': 'npm:@grapecity/wijmo.pdf.security/index.js', '@grapecity/wijmo.viewer': 'npm:@grapecity/wijmo.viewer/index.js', '@grapecity/wijmo.xlsx': 'npm:@grapecity/wijmo.xlsx/index.js', '@grapecity/wijmo.undo': 'npm:@grapecity/wijmo.undo/index.js', '@grapecity/wijmo.interop.grid': 'npm:@grapecity/wijmo.interop.grid/index.js', '@grapecity/wijmo.touch': 'npm:@grapecity/wijmo.touch/index.js', '@grapecity/wijmo.cloud': 'npm:@grapecity/wijmo.cloud/index.js', '@grapecity/wijmo.barcode': 'npm:@grapecity/wijmo.barcode/index.js', '@grapecity/wijmo.barcode.common': 'npm:@grapecity/wijmo.barcode.common/index.js', '@grapecity/wijmo.barcode.composite': 'npm:@grapecity/wijmo.barcode.composite/index.js', '@grapecity/wijmo.barcode.specialized': 'npm:@grapecity/wijmo.barcode.specialized/index.js', "@grapecity/wijmo.angular2.chart.analytics": "npm:@grapecity/wijmo.angular2.chart.analytics/index.js", "@grapecity/wijmo.angular2.chart.animation": "npm:@grapecity/wijmo.angular2.chart.animation/index.js", "@grapecity/wijmo.angular2.chart.annotation": "npm:@grapecity/wijmo.angular2.chart.annotation/index.js", "@grapecity/wijmo.angular2.chart.finance.analytics": "npm:@grapecity/wijmo.angular2.chart.finance.analytics/index.js", "@grapecity/wijmo.angular2.chart.finance": "npm:@grapecity/wijmo.angular2.chart.finance/index.js", "@grapecity/wijmo.angular2.chart.hierarchical": "npm:@grapecity/wijmo.angular2.chart.hierarchical/index.js", "@grapecity/wijmo.angular2.chart.interaction": "npm:@grapecity/wijmo.angular2.chart.interaction/index.js", "@grapecity/wijmo.angular2.chart.radar": "npm:@grapecity/wijmo.angular2.chart.radar/index.js", '@grapecity/wijmo.angular2.chart.map': 'npm:@grapecity/wijmo.angular2.chart.map/index.js', "@grapecity/wijmo.angular2.chart": "npm:@grapecity/wijmo.angular2.chart/index.js", "@grapecity/wijmo.angular2.core": "npm:@grapecity/wijmo.angular2.core/index.js", "@grapecity/wijmo.angular2.gauge": "npm:@grapecity/wijmo.angular2.gauge/index.js", "@grapecity/wijmo.angular2.grid.detail": "npm:@grapecity/wijmo.angular2.grid.detail/index.js", "@grapecity/wijmo.angular2.grid.filter": "npm:@grapecity/wijmo.angular2.grid.filter/index.js", "@grapecity/wijmo.angular2.grid.grouppanel": "npm:@grapecity/wijmo.angular2.grid.grouppanel/index.js", "@grapecity/wijmo.angular2.grid.search": "npm:@grapecity/wijmo.angular2.grid.search/index.js", "@grapecity/wijmo.angular2.grid.multirow": "npm:@grapecity/wijmo.angular2.grid.multirow/index.js", "@grapecity/wijmo.angular2.grid.sheet": "npm:@grapecity/wijmo.angular2.grid.sheet/index.js", '@grapecity/wijmo.angular2.grid.transposed': 'npm:@grapecity/wijmo.angular2.grid.transposed/index.js', '@grapecity/wijmo.angular2.grid.transposedmultirow': 'npm:@grapecity/wijmo.angular2.grid.transposedmultirow/index.js', "@grapecity/wijmo.angular2.grid": "npm:@grapecity/wijmo.angular2.grid/index.js", "@grapecity/wijmo.angular2.input": "npm:@grapecity/wijmo.angular2.input/index.js", "@grapecity/wijmo.angular2.olap": "npm:@grapecity/wijmo.angular2.olap/index.js", "@grapecity/wijmo.angular2.viewer": "npm:@grapecity/wijmo.angular2.viewer/index.js", "@grapecity/wijmo.angular2.nav": "npm:@grapecity/wijmo.angular2.nav/index.js", "@grapecity/wijmo.angular2.directivebase": "npm:@grapecity/wijmo.angular2.directivebase/index.js", '@grapecity/wijmo.angular2.barcode.common': 'npm:@grapecity/wijmo.angular2.barcode.common/index.js', '@grapecity/wijmo.angular2.barcode.composite': 'npm:@grapecity/wijmo.angular2.barcode.composite/index.js', '@grapecity/wijmo.angular2.barcode.specialized': 'npm:@grapecity/wijmo.angular2.barcode.specialized/index.js', 'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css', 'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js', "@angular/common/http": "https://cdn.jsdelivr.net/npm/@angular/common@16.2.6/fesm2022/http.mjs", "@angular/core": "https://cdn.jsdelivr.net/npm/@angular/core@16.2.6/fesm2022/core.mjs", "@angular/platform-browser": "https://cdn.jsdelivr.net/npm/@angular/platform-browser@16.2.6/fesm2022/platform-browser.mjs", "@angular/common": "https://cdn.jsdelivr.net/npm/@angular/common@16.2.6/fesm2022/common.mjs", "@angular/compiler": "https://cdn.jsdelivr.net/npm/@angular/compiler@16.2.6/fesm2022/compiler.mjs", "@angular/forms": "https://cdn.jsdelivr.net/npm/@angular/forms@16.2.6/fesm2022/forms.mjs", "@angular/localize": "https://cdn.jsdelivr.net/npm/@angular/localize@16.2.6/fesm2022/localize.mjs", "@angular/platform-browser-dynamic": "https://cdn.jsdelivr.net/npm/@angular/platform-browser-dynamic@16.2.6/fesm2022/platform-browser-dynamic.mjs", }, // packages tells the System loader how to load when no filename and/or no extension packages: { "./src": { defaultExtension: 'ts' }, "node_modules": { defaultExtension: 'js' }, wijmo: { defaultExtension: 'js', } } }); })(this);

ScatterGL (React)

이 샘플은 고성능 WebGL 렌더링을 사용하여, 대량의 데이터가 있는 산포도(Scatter Chart)를 보여줍니다.

이 데모는 React를 기반으로합니다.

import 'bootstrap.css'; import '@grapecity/wijmo.styles/wijmo.css'; import './app.css'; // import * as React from 'react'; import * as ReactDOM from 'react-dom/client'; // import { isIE } from "@grapecity/wijmo"; import * as wjChart from "@grapecity/wijmo.chart"; import { WebGLRenderEngine } from "@grapecity/wijmo.chart.webgl"; import { Menu, MenuItem } from '@grapecity/wijmo.react.input'; import { FlexChart, FlexChartAxis, FlexChartSeries } from '@grapecity/wijmo.react.chart'; import { FlexChartGestures } from '@grapecity/wijmo.react.chart.interaction'; import { getData } from './data'; // // class App extends React.Component { // constructor(props) { super(props); this._webglEng = new WebGLRenderEngine(); this._svgEng = new wjChart.SvgRenderEngine(); // this.gesturesInitialized = (s) => { this._gestures = s; }; // this.numPointsChanged = (s) => { this.setState({ numberOfPoints: s.selectedValue }, this.refreshData); }; // this.numSeriesChanged = (s) => { this.setState({ numberOfSeries: s.selectedValue }, this.refreshData); }; // this.symbolChanged = (s) => { this.setState({ seriesSymbol: s.selectedValue }); }; // this.sizeChanged = (s) => { this.setState({ symbolSize: s.selectedValue }); }; // this.engineChanged = (e) => { this.setState({ useWebGL: e.target.checked }); }; // this.refreshData = () => { const { numberOfSeries: nser, numberOfPoints: npts, } = this.state; const data = []; for (let i = 0; i < nser; i++) { data.push(getData(Math.random() - 0.5, Math.random() - 0.5, npts / nser, 0.5 * (1 - i / nser))); } this.setState({ data }); }; // this.resetZoom = () => { this._gestures.reset(); }; this.state = { numberOfPoints: isIE() ? 10000 : 100000, numberOfSeries: 1, seriesSymbol: 'Dot', symbolSize: 3, useWebGL: true, data: [], }; } // render() { return (<div className='container-fluid'> <div className="row"> <div className="col-sm-12"> <Menu header="NumPoints" value={this.state.numberOfPoints} itemClicked={this.numPointsChanged}> <MenuItem value={1000}>1K</MenuItem> <MenuItem value={10000}>10K</MenuItem> <MenuItem value={100000}>100K</MenuItem> {!isIE() && <MenuItem value={200000}>200K</MenuItem>} {!isIE() && <MenuItem value={500000}>500K</MenuItem>} </Menu> <Menu header="NumSeries" value={this.state.numberOfSeries} itemClicked={this.numSeriesChanged}> <MenuItem value={1}>1</MenuItem> <MenuItem value={2}>2</MenuItem> <MenuItem value={4}>4</MenuItem> <MenuItem value={8}>8</MenuItem> </Menu> <Menu header="Symbol" value={this.state.seriesSymbol} itemClicked={this.symbolChanged}> <MenuItem value="Dot">Dot</MenuItem> <MenuItem value="Box">Box</MenuItem> </Menu> <Menu header="Size" value={this.state.symbolSize} itemClicked={this.sizeChanged}> <MenuItem value={3}>3</MenuItem> <MenuItem value={5}>5</MenuItem> <MenuItem value={10}>10</MenuItem> <MenuItem value={20}>20</MenuItem> <MenuItem value={50}>50</MenuItem> </Menu> <label> Use WebGL <input id="webgl" type="checkbox" checked={this.state.useWebGL} onChange={this.engineChanged}/> </label> </div> </div> <div className="row"> <div className="col-sm-12"> <FlexChart renderEngine={this.renderEngine} chartType="Scatter" bindingX="x" binding="y" symbolSize={this.state.symbolSize}> <FlexChartAxis wjProperty="axisX" min={-2} max={2}/> <FlexChartAxis wjProperty="axisY" min={-2} max={2} axisLine majorGrid={false}/> <FlexChartGestures interactiveAxes="XY" mouseAction="Zoom" initialized={this.gesturesInitialized} scaleY={1} posY={0.5} scaleX={1} posX={0.5}/> {this.state.data.map((series, i) => { return (<FlexChartSeries key={i} itemsSource={series} name={`ser ${i + 1}`} symbolStyle={{ strokeWidth: 0 }} symbolMarker={this.state.seriesSymbol}/>); })} </FlexChart> </div> </div> <div className="row"> <div className="col-sm-12"> <button id="btnNew" onClick={this.refreshData}>Refresh Data</button> <button id="btnReset" onClick={this.resetZoom}>Reset Zoom</button> </div> </div> </div>); } // componentDidMount() { this.refreshData(); } // get renderEngine() { return this.state.useWebGL ? this._webglEng : this._svgEng; } } setTimeout(() => { const container = document.getElementById('app'); if (container) { const root = ReactDOM.createRoot(container); root.render(<App />); } }, 100);
<!DOCTYPE html> <html lang="en"> <head> <meta charset="utf-8"> <meta http-equiv="X-UA-Compatible" content="IE=edge"> <title>WebGL</title> <meta name="viewport" content="width=device-width, initial-scale=1.0"> <!-- SystemJS --> <script src="node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('./src/app'); </script> </head> <body> <div id="app"></div> </body> </html>
.wj-flexchart { width: 600px; height: 500px; margin: 0; }
export function getData(cx, cy, n, maxr) { let data = new Array(n); let r0 = 0.1 + maxr; for (let i = 0; i < data.length; i++) { let a = 2 * Math.PI * Math.random(); let r = r0 * Math.sqrt(-2 * Math.log(Math.random())); data[i] = { x: cx + r * Math.cos(a), y: cy + r * Math.sin(a) }; } return data; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true, react: true }, meta: { '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { 'jszip': 'npm:jszip/dist/jszip.js', '@grapecity/wijmo': 'npm:@grapecity/wijmo/index.js', '@grapecity/wijmo.input': 'npm:@grapecity/wijmo.input/index.js', '@grapecity/wijmo.styles': 'npm:@grapecity/wijmo.styles', '@grapecity/wijmo.cultures': 'npm:@grapecity/wijmo.cultures', '@grapecity/wijmo.chart': 'npm:@grapecity/wijmo.chart/index.js', '@grapecity/wijmo.chart.analytics': 'npm:@grapecity/wijmo.chart.analytics/index.js', '@grapecity/wijmo.chart.animation': 'npm:@grapecity/wijmo.chart.animation/index.js', '@grapecity/wijmo.chart.annotation': 'npm:@grapecity/wijmo.chart.annotation/index.js', '@grapecity/wijmo.chart.finance': 'npm:@grapecity/wijmo.chart.finance/index.js', '@grapecity/wijmo.chart.finance.analytics': 'npm:@grapecity/wijmo.chart.finance.analytics/index.js', '@grapecity/wijmo.chart.hierarchical': 'npm:@grapecity/wijmo.chart.hierarchical/index.js', '@grapecity/wijmo.chart.interaction': 'npm:@grapecity/wijmo.chart.interaction/index.js', '@grapecity/wijmo.chart.radar': 'npm:@grapecity/wijmo.chart.radar/index.js', '@grapecity/wijmo.chart.render': 'npm:@grapecity/wijmo.chart.render/index.js', '@grapecity/wijmo.chart.webgl': 'npm:@grapecity/wijmo.chart.webgl/index.js', '@grapecity/wijmo.chart.map': 'npm:@grapecity/wijmo.chart.map/index.js', '@grapecity/wijmo.gauge': 'npm:@grapecity/wijmo.gauge/index.js', '@grapecity/wijmo.grid': 'npm:@grapecity/wijmo.grid/index.js', '@grapecity/wijmo.grid.detail': 'npm:@grapecity/wijmo.grid.detail/index.js', '@grapecity/wijmo.grid.filter': 'npm:@grapecity/wijmo.grid.filter/index.js', '@grapecity/wijmo.grid.search': 'npm:@grapecity/wijmo.grid.search/index.js', '@grapecity/wijmo.grid.grouppanel': 'npm:@grapecity/wijmo.grid.grouppanel/index.js', '@grapecity/wijmo.grid.multirow': 'npm:@grapecity/wijmo.grid.multirow/index.js', '@grapecity/wijmo.grid.transposed': 'npm:@grapecity/wijmo.grid.transposed/index.js', '@grapecity/wijmo.grid.transposedmultirow': 'npm:@grapecity/wijmo.grid.transposedmultirow/index.js', '@grapecity/wijmo.grid.pdf': 'npm:@grapecity/wijmo.grid.pdf/index.js', '@grapecity/wijmo.grid.sheet': 'npm:@grapecity/wijmo.grid.sheet/index.js', '@grapecity/wijmo.grid.xlsx': 'npm:@grapecity/wijmo.grid.xlsx/index.js', '@grapecity/wijmo.grid.selector': 'npm:@grapecity/wijmo.grid.selector/index.js', '@grapecity/wijmo.grid.cellmaker': 'npm:@grapecity/wijmo.grid.cellmaker/index.js', '@grapecity/wijmo.grid.immutable': 'npm:@grapecity/wijmo.grid.immutable/index.js', '@grapecity/wijmo.touch': 'npm:@grapecity/wijmo.touch/index.js', '@grapecity/wijmo.cloud': 'npm:@grapecity/wijmo.cloud/index.js', '@grapecity/wijmo.nav': 'npm:@grapecity/wijmo.nav/index.js', '@grapecity/wijmo.odata': 'npm:@grapecity/wijmo.odata/index.js', '@grapecity/wijmo.olap': 'npm:@grapecity/wijmo.olap/index.js', '@grapecity/wijmo.rest': 'npm:@grapecity/wijmo.rest/index.js', '@grapecity/wijmo.pdf': 'npm:@grapecity/wijmo.pdf/index.js', '@grapecity/wijmo.pdf.security': 'npm:@grapecity/wijmo.pdf.security/index.js', '@grapecity/wijmo.viewer': 'npm:@grapecity/wijmo.viewer/index.js', '@grapecity/wijmo.xlsx': 'npm:@grapecity/wijmo.xlsx/index.js', '@grapecity/wijmo.undo': 'npm:@grapecity/wijmo.undo/index.js', '@grapecity/wijmo.interop.grid': 'npm:@grapecity/wijmo.interop.grid/index.js', '@grapecity/wijmo.barcode': 'npm:@grapecity/wijmo.barcode/index.js', '@grapecity/wijmo.barcode.common': 'npm:@grapecity/wijmo.barcode.common/index.js', '@grapecity/wijmo.barcode.composite': 'npm:@grapecity/wijmo.barcode.composite/index.js', '@grapecity/wijmo.barcode.specialized': 'npm:@grapecity/wijmo.barcode.specialized/index.js', "@grapecity/wijmo.react.chart.analytics": "npm:@grapecity/wijmo.react.chart.analytics/index.js", "@grapecity/wijmo.react.chart.animation": "npm:@grapecity/wijmo.react.chart.animation/index.js", "@grapecity/wijmo.react.chart.annotation": "npm:@grapecity/wijmo.react.chart.annotation/index.js", "@grapecity/wijmo.react.chart.finance.analytics": "npm:@grapecity/wijmo.react.chart.finance.analytics/index.js", "@grapecity/wijmo.react.chart.finance": "npm:@grapecity/wijmo.react.chart.finance/index.js", "@grapecity/wijmo.react.chart.hierarchical": "npm:@grapecity/wijmo.react.chart.hierarchical/index.js", "@grapecity/wijmo.react.chart.interaction": "npm:@grapecity/wijmo.react.chart.interaction/index.js", "@grapecity/wijmo.react.chart.radar": "npm:@grapecity/wijmo.react.chart.radar/index.js", "@grapecity/wijmo.react.chart": "npm:@grapecity/wijmo.react.chart/index.js", "@grapecity/wijmo.react.core": "npm:@grapecity/wijmo.react.core/index.js", '@grapecity/wijmo.react.chart.map': 'npm:@grapecity/wijmo.react.chart.map/index.js', "@grapecity/wijmo.react.gauge": "npm:@grapecity/wijmo.react.gauge/index.js", "@grapecity/wijmo.react.grid.detail": "npm:@grapecity/wijmo.react.grid.detail/index.js", "@grapecity/wijmo.react.grid.filter": "npm:@grapecity/wijmo.react.grid.filter/index.js", "@grapecity/wijmo.react.grid.grouppanel": "npm:@grapecity/wijmo.react.grid.grouppanel/index.js", '@grapecity/wijmo.react.grid.search': 'npm:@grapecity/wijmo.react.grid.search/index.js', "@grapecity/wijmo.react.grid.multirow": "npm:@grapecity/wijmo.react.grid.multirow/index.js", "@grapecity/wijmo.react.grid.sheet": "npm:@grapecity/wijmo.react.grid.sheet/index.js", '@grapecity/wijmo.react.grid.transposed': 'npm:@grapecity/wijmo.react.grid.transposed/index.js', '@grapecity/wijmo.react.grid.transposedmultirow': 'npm:@grapecity/wijmo.react.grid.transposedmultirow/index.js', '@grapecity/wijmo.react.grid.immutable': 'npm:@grapecity/wijmo.react.grid.immutable/index.js', "@grapecity/wijmo.react.grid": "npm:@grapecity/wijmo.react.grid/index.js", "@grapecity/wijmo.react.input": "npm:@grapecity/wijmo.react.input/index.js", "@grapecity/wijmo.react.olap": "npm:@grapecity/wijmo.react.olap/index.js", "@grapecity/wijmo.react.viewer": "npm:@grapecity/wijmo.react.viewer/index.js", "@grapecity/wijmo.react.nav": "npm:@grapecity/wijmo.react.nav/index.js", "@grapecity/wijmo.react.base": "npm:@grapecity/wijmo.react.base/index.js", '@grapecity/wijmo.react.barcode.common': 'npm:@grapecity/wijmo.react.barcode.common/index.js', '@grapecity/wijmo.react.barcode.composite': 'npm:@grapecity/wijmo.react.barcode.composite/index.js', '@grapecity/wijmo.react.barcode.specialized': 'npm:@grapecity/wijmo.react.barcode.specialized/index.js', 'jszip': 'npm:jszip/dist/jszip.js', 'react': 'npm:react/umd/react.production.min.js', 'react-dom': 'npm:react-dom/umd/react-dom.production.min.js', 'react-dom/client': 'npm:react-dom/umd/react-dom.production.min.js', 'redux': 'npm:redux/dist/redux.min.js', 'react-redux': 'npm:react-redux/dist/react-redux.min.js', 'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'jsx' }, "node_modules": { defaultExtension: 'js' }, } }); })(this);

ScatterGL (Vue)

이 샘플은 고성능 WebGL 렌더링을 사용하여, 대량의 데이터가 있는 산포도(Scatter Chart)를 보여줍니다.

이 데모는 Vue를 기반으로합니다.

<template> <div class="container-fluid"> <div class="row"> <div class="col-sm-12"> <wj-menu header="NumPoints" :value="numberOfPoints" :itemClicked="numPointsChanged" > <wj-menu-item :value="1000">1K</wj-menu-item> <wj-menu-item :value="10000">10K</wj-menu-item> <wj-menu-item :value="100000">100K</wj-menu-item> <wj-menu-item v-if="notIE" :value="200000">200K</wj-menu-item> <wj-menu-item v-if="notIE" :value="500000">500K</wj-menu-item> </wj-menu> <wj-menu header="NumSeries" :value="numberOfSeries" :itemClicked="numSeriesChanged" > <wj-menu-item :value="1">1</wj-menu-item> <wj-menu-item :value="2">2</wj-menu-item> <wj-menu-item :value="4">4</wj-menu-item> <wj-menu-item :value="8">8</wj-menu-item> </wj-menu> <wj-menu header="Symbol" :value="seriesSymbol" :itemClicked="symbolChanged" > <wj-menu-item :value="'Dot'">Dot</wj-menu-item> <wj-menu-item :value="'Box'">Box</wj-menu-item> </wj-menu> <wj-menu header="Size" :value="symbolSize" :itemClicked="sizeChanged"> <wj-menu-item :value="3">3</wj-menu-item> <wj-menu-item :value="5">5</wj-menu-item> <wj-menu-item :value="10">10</wj-menu-item> <wj-menu-item :value="20">20</wj-menu-item> <wj-menu-item :value="50">50</wj-menu-item> </wj-menu> <label> Use WebGL <input id="webgl" type="checkbox" v-model="useWebGL" /> </label> </div> </div> <div class="row"> <div class="col-sm-12"> <wj-flex-chart :initialized="initialize" :renderEngine="renderEngine" chartType="Scatter" bindingX="x" binding="y" :symbolSize="symbolSize" > <wj-flex-chart-axis wjProperty="axisX" :min="-2" :max="2" /> <wj-flex-chart-axis wjProperty="axisY" :min="-2" :max="2" :axisLine="true" :majorGrid="false" /> <wj-flex-chart-gestures interactiveAxes="XY" mouseAction="Zoom" :initialized="gesturesInitialized" :scaleY="1" :posY="0.5" :scaleX="1" :posX="0.5" /> </wj-flex-chart> </div> </div> <div class="row"> <div class="col-sm-12"> <button id="btnNew" @click="refreshData">Refresh Data</button> <button id="btnReset" @click="resetZoom">Reset Zoom</button> </div> </div> </div> </template> <script> import 'bootstrap.css'; import "@grapecity/wijmo.styles/wijmo.css"; import Vue from 'vue'; import "@grapecity/wijmo.vue2.input"; import "@grapecity/wijmo.vue2.chart"; import "@grapecity/wijmo.vue2.chart.interaction"; import { isIE } from "@grapecity/wijmo"; import * as wjChart from "@grapecity/wijmo.chart"; import { WebGLRenderEngine } from '@grapecity/wijmo.chart.webgl'; import { getData } from './data'; let App = Vue.extend({ name: 'app', data: function() { return { numberOfPoints: isIE() ? 10000 : 100000, numberOfSeries: 1, seriesSymbol: 'Dot', symbolSize: 3, useWebGL: true, notIE: !isIE() }; }, created() { this.webglEng = new WebGLRenderEngine(); this.svgEng = new wjChart.SvgRenderEngine(); }, mounted() { this.refreshData(); }, computed: { renderEngine: function () { return this.useWebGL ? this.webglEng : this.svgEng; } }, methods: { initialize(chart){ this.chart = chart; }, numPointsChanged: function (s) { this.numberOfPoints = s.selectedValue; this.refreshData(); }, numSeriesChanged: function (s) { this.numberOfSeries = s.selectedValue; this.refreshData(); }, symbolChanged: function (s) { this.seriesSymbol = s.selectedValue; this.chart.beginUpdate(); this.chart.series.forEach(s => s.symbolMarker = this.seriesSymbol); this.chart.endUpdate(); }, sizeChanged: function (s) { this.symbolSize = s.selectedValue; this.chart.beginUpdate(); this.chart.series.forEach(s => s.symbolSize = this.symbolSize); this.chart.endUpdate(); }, refreshData: function () { const data = []; const nser = this.numberOfSeries; const npts = this.numberOfPoints; const chart = this.chart; chart.beginUpdate(); chart.series.clear(); for (let i = 0; i < nser; i++) { chart.series.push(new wjChart.Series( { itemsSource: getData(Math.random() - 0.5, Math.random() - 0.5, npts / nser, 0.5 * (1 - i / nser)), name:'ser ' + (i + 1), symbolStyle: { strokeWidth: 0}, symbolMarker: this.seriesSymbol, symbolSize: this.symbolSize } )); } chart.endUpdate(); }, gesturesInitialized: function (s) { this.gestures = s; }, resetZoom: function() { this.gestures.reset(); } }, }); new Vue({ render: h => h(App) }).$mount('#app'); </script> <style> .wj-flexchart { width: 600px; height: 500px !important; margin: 0; } </style>
<!DOCTYPE html> <html lang="en"> <head> <meta charset="utf-8"> <meta http-equiv="X-UA-Compatible" content="IE=edge"> <title>WebGL</title> <meta name="viewport" content="width=device-width, initial-scale=1.0"> <!-- SystemJS --> <script src="node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('./src/app.vue'); </script> </head> <body> <div id="app"></div> </body> </html>
export function getData(cx, cy, n, maxr) { let data = new Array(n); let r0 = 0.1 + maxr; for (let i = 0; i < data.length; i++) { let a = 2 * Math.PI * Math.random(); let r = r0 * Math.sqrt(-2 * Math.log(Math.random())); data[i] = { x: cx + r * Math.cos(a), y: cy + r * Math.sin(a) }; } return data; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, meta: { '*.css': { loader: 'css' }, '*.vue': { loader: 'vue-loader' } //'*.vue': { loader: 'systemjs-plugin-vue' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { '@grapecity/wijmo': 'npm:@grapecity/wijmo/index.js', '@grapecity/wijmo.input': 'npm:@grapecity/wijmo.input/index.js', '@grapecity/wijmo.styles': 'npm:@grapecity/wijmo.styles', '@grapecity/wijmo.cultures': 'npm:@grapecity/wijmo.cultures', '@grapecity/wijmo.chart': 'npm:@grapecity/wijmo.chart/index.js', '@grapecity/wijmo.chart.analytics': 'npm:@grapecity/wijmo.chart.analytics/index.js', '@grapecity/wijmo.chart.animation': 'npm:@grapecity/wijmo.chart.animation/index.js', '@grapecity/wijmo.chart.annotation': 'npm:@grapecity/wijmo.chart.annotation/index.js', '@grapecity/wijmo.chart.finance': 'npm:@grapecity/wijmo.chart.finance/index.js', '@grapecity/wijmo.chart.finance.analytics': 'npm:@grapecity/wijmo.chart.finance.analytics/index.js', '@grapecity/wijmo.chart.hierarchical': 'npm:@grapecity/wijmo.chart.hierarchical/index.js', '@grapecity/wijmo.chart.interaction': 'npm:@grapecity/wijmo.chart.interaction/index.js', '@grapecity/wijmo.chart.radar': 'npm:@grapecity/wijmo.chart.radar/index.js', '@grapecity/wijmo.chart.render': 'npm:@grapecity/wijmo.chart.render/index.js', '@grapecity/wijmo.chart.webgl': 'npm:@grapecity/wijmo.chart.webgl/index.js', '@grapecity/wijmo.chart.map': 'npm:@grapecity/wijmo.chart.map/index.js', '@grapecity/wijmo.gauge': 'npm:@grapecity/wijmo.gauge/index.js', '@grapecity/wijmo.grid': 'npm:@grapecity/wijmo.grid/index.js', '@grapecity/wijmo.grid.detail': 'npm:@grapecity/wijmo.grid.detail/index.js', '@grapecity/wijmo.grid.filter': 'npm:@grapecity/wijmo.grid.filter/index.js', '@grapecity/wijmo.grid.search': 'npm:@grapecity/wijmo.grid.search/index.js', '@grapecity/wijmo.grid.grouppanel': 'npm:@grapecity/wijmo.grid.grouppanel/index.js', '@grapecity/wijmo.grid.multirow': 'npm:@grapecity/wijmo.grid.multirow/index.js', '@grapecity/wijmo.grid.transposed': 'npm:@grapecity/wijmo.grid.transposed/index.js', '@grapecity/wijmo.grid.transposedmultirow': 'npm:@grapecity/wijmo.grid.transposedmultirow/index.js', '@grapecity/wijmo.grid.pdf': 'npm:@grapecity/wijmo.grid.pdf/index.js', '@grapecity/wijmo.grid.sheet': 'npm:@grapecity/wijmo.grid.sheet/index.js', '@grapecity/wijmo.grid.xlsx': 'npm:@grapecity/wijmo.grid.xlsx/index.js', '@grapecity/wijmo.grid.selector': 'npm:@grapecity/wijmo.grid.selector/index.js', '@grapecity/wijmo.grid.cellmaker': 'npm:@grapecity/wijmo.grid.cellmaker/index.js', '@grapecity/wijmo.nav': 'npm:@grapecity/wijmo.nav/index.js', '@grapecity/wijmo.odata': 'npm:@grapecity/wijmo.odata/index.js', '@grapecity/wijmo.olap': 'npm:@grapecity/wijmo.olap/index.js', '@grapecity/wijmo.rest': 'npm:@grapecity/wijmo.rest/index.js', '@grapecity/wijmo.pdf': 'npm:@grapecity/wijmo.pdf/index.js', '@grapecity/wijmo.pdf.security': 'npm:@grapecity/wijmo.pdf.security/index.js', '@grapecity/wijmo.viewer': 'npm:@grapecity/wijmo.viewer/index.js', '@grapecity/wijmo.xlsx': 'npm:@grapecity/wijmo.xlsx/index.js', '@grapecity/wijmo.undo': 'npm:@grapecity/wijmo.undo/index.js', '@grapecity/wijmo.interop.grid': 'npm:@grapecity/wijmo.interop.grid/index.js', '@grapecity/wijmo.touch': 'npm:@grapecity/wijmo.touch/index.js', '@grapecity/wijmo.cloud': 'npm:@grapecity/wijmo.cloud/index.js', '@grapecity/wijmo.barcode': 'npm:@grapecity/wijmo.barcode/index.js', '@grapecity/wijmo.barcode.common': 'npm:@grapecity/wijmo.barcode.common/index.js', '@grapecity/wijmo.barcode.composite': 'npm:@grapecity/wijmo.barcode.composite/index.js', '@grapecity/wijmo.barcode.specialized': 'npm:@grapecity/wijmo.barcode.specialized/index.js', "@grapecity/wijmo.vue2.chart.analytics": "npm:@grapecity/wijmo.vue2.chart.analytics/index.js", "@grapecity/wijmo.vue2.chart.animation": "npm:@grapecity/wijmo.vue2.chart.animation/index.js", "@grapecity/wijmo.vue2.chart.annotation": "npm:@grapecity/wijmo.vue2.chart.annotation/index.js", "@grapecity/wijmo.vue2.chart.finance.analytics": "npm:@grapecity/wijmo.vue2.chart.finance.analytics/index.js", "@grapecity/wijmo.vue2.chart.finance": "npm:@grapecity/wijmo.vue2.chart.finance/index.js", "@grapecity/wijmo.vue2.chart.hierarchical": "npm:@grapecity/wijmo.vue2.chart.hierarchical/index.js", "@grapecity/wijmo.vue2.chart.interaction": "npm:@grapecity/wijmo.vue2.chart.interaction/index.js", "@grapecity/wijmo.vue2.chart.radar": "npm:@grapecity/wijmo.vue2.chart.radar/index.js", '@grapecity/wijmo.vue2.chart.map': 'npm:@grapecity/wijmo.vue2.chart.map/index.js', "@grapecity/wijmo.vue2.chart": "npm:@grapecity/wijmo.vue2.chart/index.js", "@grapecity/wijmo.vue2.core": "npm:@grapecity/wijmo.vue2.core/index.js", "@grapecity/wijmo.vue2.gauge": "npm:@grapecity/wijmo.vue2.gauge/index.js", "@grapecity/wijmo.vue2.grid.detail": "npm:@grapecity/wijmo.vue2.grid.detail/index.js", "@grapecity/wijmo.vue2.grid.filter": "npm:@grapecity/wijmo.vue2.grid.filter/index.js", "@grapecity/wijmo.vue2.grid.grouppanel": "npm:@grapecity/wijmo.vue2.grid.grouppanel/index.js", '@grapecity/wijmo.vue2.grid.search': 'npm:@grapecity/wijmo.vue2.grid.search/index.js', "@grapecity/wijmo.vue2.grid.multirow": "npm:@grapecity/wijmo.vue2.grid.multirow/index.js", "@grapecity/wijmo.vue2.grid.sheet": "npm:@grapecity/wijmo.vue2.grid.sheet/index.js", '@grapecity/wijmo.vue2.grid.transposed': 'npm:@grapecity/wijmo.vue2.grid.transposed/index.js', '@grapecity/wijmo.vue2.grid.transposedmultirow': 'npm:@grapecity/wijmo.vue2.grid.transposedmultirow/index.js', "@grapecity/wijmo.vue2.grid": "npm:@grapecity/wijmo.vue2.grid/index.js", "@grapecity/wijmo.vue2.input": "npm:@grapecity/wijmo.vue2.input/index.js", "@grapecity/wijmo.vue2.olap": "npm:@grapecity/wijmo.vue2.olap/index.js", "@grapecity/wijmo.vue2.viewer": "npm:@grapecity/wijmo.vue2.viewer/index.js", "@grapecity/wijmo.vue2.nav": "npm:@grapecity/wijmo.vue2.nav/index.js", "@grapecity/wijmo.vue2.base": "npm:@grapecity/wijmo.vue2.base/index.js", '@grapecity/wijmo.vue2.barcode.common': 'npm:@grapecity/wijmo.vue2.barcode.common/index.js', '@grapecity/wijmo.vue2.barcode.composite': 'npm:@grapecity/wijmo.vue2.barcode.composite/index.js', '@grapecity/wijmo.vue2.barcode.specialized': 'npm:@grapecity/wijmo.vue2.barcode.specialized/index.js', 'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css', 'jszip': 'npm:jszip/dist/jszip.js', 'css': 'npm:systemjs-plugin-css/css.js', 'vue': 'npm:vue/dist/vue.min.js', 'vue-loader': 'npm:systemjs-vue-browser/index.js', //'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'js' }, rxjs: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' }, wijmo: { defaultExtension: 'js', } } }); })(this);